#!/usr/bin/perl
# Program name: nmon2ddl.pl
# Purpose - convert nmon.sql file into ddl file for mysql
# Author - Bruce Spencer
# Disclaimer:  this provided "as is".  
# Date - March 2007
#
$version="1.0. March 2007";
#
# Usage
# To make file with the "create table" statements.....
#
# 1.  Warning this is a little counter intuitive.  
#     Make the "insert into" sql file before we create the tables
#     
#     nmon2mysql.pl filename.nmon > filename.sql
#
# 2.  Make the SQL create statements from the filename.sql
#
#     nmon2ddl.pl filename.sql | sed -f nmon2ddl.sed> nmon.ddl
#
# 3.  Create database tables (do this only once!!!)
#
#     mysql -u root nmon < nmon.ddl
#
# 4.  Upload data into tables
#
#     mysql -u root nmon < filename.sql
#

$USAGE="nmon2ddl.pl nmon.sql | sed -f nmon2ddl.sed> nmon.ddl";

####################################################################
#############		Main Program 			############
####################################################################

if ( @ARGV < 1 ) {
	print ("$USAGE \n");
	exit;
	}

unless ( open(DDL, $ARGV[0]) ) { 
	die("Can not open $ARGV[0]\n"); 
  }

# print first 3 lines (AIXVer, nmon-ver, use nmon)
$input=<DDL>; print ("$input");
$input=<DDL>; print ("$input");
$input=<DDL>; print ("$input\n");

$input=<DDL>;
while ($input ne "") {

  if ($input !~ /^insert/){ 
	$input=<DDL>;
	next;
  } # end if

  @cols=split(/\s+/,$input);

  print ("# drop table $cols[2];\n");
  print ("create table $cols[2]\n(\n");
  $input=<DDL>;

  # Remove parentheses around column names
  $cols[3]=~s/\(//;
  $cols[3]=~s/\)//;
  @vname=split(/,/,$cols[3]);

  $n=@vname;
  $n--;
  for ($i=0;$i<$n;$i++) {
	printf("%20s\tchar(x),\n",$vname[$i]);
  }# end for
  printf("%15s\tchar(x)\n);\n\n",$vname[$n]);

  $input=<DDL>;

} # end while

